clc
clear all
close all
addpath('xxxx') % Add path to wawi toolbox
import wawi.* 
%% INPUT
InputPrefix='Sulafjorden_TD21_S1-G1_'; % Prefix in front of imported filenames 
%% Load structural props
load(strcat(InputPrefix,'AbaqusResults.mat')')

%% Plot mode 1 - H1
fig=figure('Position',[10 10 1500 100]);
mode = 1;
name = '1-H1';
modes=[];
modes(end+1)=mode;
tmp = max(abs([phi(2054:6:end,mode); phi(2055:6:end,mode); phi(2056:6:end,mode)]));
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 2 - H2
fig=figure('Position',[10 10 1500 100]);
mode = 2;
name = '2-H2';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 3 - V1
fig=figure('Position',[10 10 1500 100]);
mode = 3;
name = '3-V1';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 4 - V2
fig=figure('Position',[10 10 1500 100]);
mode = 4;
name = '4-V2';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 5 - V3
fig=figure('Position',[10 10 1500 100]);
mode = 5;
name = '5-V3';
modes(end+1)=mode;
tmp = max(abs([phi(2054:6:end,mode); phi(2055:6:end,mode); phi(2056:6:end,mode)]));
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))

%% Plot mode 6 - V4
fig=figure('Position',[10 10 1500 100]);
mode = 6;
name = '6-V4';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 7 - H3
fig=figure('Position',[10 10 1500 100]);
mode = 7;
name = '7-H3';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 12 - V5
fig=figure('Position',[10 10 1500 100]);
mode = 12;
name = '12-V5';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 15 - V6
fig=figure('Position',[10 10 1500 100]);
mode = 15;
name = '15-V6';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 20 - H4
fig=figure('Position',[10 10 1500 100]);
mode = 20;
name = '20-H4';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 21 - V7
fig=figure('Position',[10 10 1500 100]);
mode = 21;
name = '21-V7';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 23 - T1
fig=figure('Position',[10 10 1500 100]);
mode = 23;
name = '23-T1';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 24 - V8
fig=figure('Position',[10 10 1500 100]);
mode = 24;
name = '24-V8';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 33 - V9
fig=figure('Position',[10 10 1500 100]);
mode = 33;
name = '33-V9';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 35 - T2
fig=figure('Position',[10 10 1500 100]);
mode = 35;
name = '35-T2';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 38 - V10
fig=figure('Position',[10 10 1500 100]);
mode = 38;
name = '38-V10';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 41 - V11
fig=figure('Position',[10 10 1500 100]);
mode = 41;
name = '41-V11';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 42 - H5
fig=figure('Position',[10 10 1500 100]);
mode = 42;
name = '42-H5';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 43 - V12
fig=figure('Position',[10 10 1500 100]);
mode = 43;
name = '43-V12';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))
%% Plot mode 50 - V13
fig=figure('Position',[10 10 1500 100]);
mode = 50;
name = '50-V13';
modes(end+1)=mode;
x=nodes(343:end,2);
y=phi(2054:6:end,mode);
z=phi(2055:6:end,mode);
rot=phi(2056:6:end,mode);
subplot(1,3,1)
plot(x,y,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[],'Position',[0.0100    0.1100    0.3200    0.8150])
subplot(1,3,2)
plot(x,z,'.')
xlim([-1400 1400])
ylim([-1 1])
set(gca,'XTick',[],'YTick',[], 'Position',[0.3400    0.1100    0.3200    0.8150])
subplot(1,3,3)
plot(x,rot,'.')
xlim([-1400 1400])
ylim([-0.06 0.06])
set(gca,'XTick',[],'YTick',[], 'Position',[0.6700    0.1100    0.3200    0.8150])
saveas(fig,strcat(InputPrefix,name,'.jpg'))

%%
[ genMs, genKs ] = wawi.misc.construct_modal_matrices(f, Mg);
n=0;
modes=sort(modes);
for i=modes
    n=n+1;
    data(n,1)=i;
    data(n,2)=n;
    data(n,3)=genMs(i,i);
    data(n,4)=genKs(i,i);
    data(n,5)=f(i);
end
save(strcat(InputPrefix,'ModalProperties.mat'),'data')
