%This script generates the static coefficeints for the twin deck section
%TD21
%%
clc
clear all
close all
addpath('xxxx') %% Add path to the w3t toolbox
import w3t.*
%% Section length
L=2.640;             % Length of the section
%% TD21_S1_G1
D=50/1000;  % Height of the section
B=750/1000; % Width of the section. 
pathData = '.\Data\TD21_S1_G1\';
pathRsultsFolder = '.\Results\TD21_S1_G1\';
files = {'TD21_S1-G1_02_00_004.mat'  'TD21_S1-G1_02_00_006.mat' 'TD21_S1-G1_02_00_007.mat'} ;
file0 = 'TD21_S1-G1_02_00_000.mat';
staticCoeffs(files,file0,pathRsultsFolder,pathData,B,D,L)
close all
%% TD21_S1_G2
D=50/1000;  % Height of the section
B=850/1000; % Width of the section. 
pathData = '.\Data\TD21_S1_G2\';
pathRsultsFolder = '.\Results\TD21_S1_G2\';
files = {'TD21_S1-G2_02_00_002.mat'  'TD21_S1-G2_02_00_003.mat' 'TD21_S1-G2_02_00_004.mat'} ;
file0 = 'TD21_S1-G2_02_00_001.mat';
staticCoeffs(files,file0,pathRsultsFolder,pathData,B,D,L)
close all
%% TD21_S1_G3
D=50/1000;  % Height of the section
B=950/1000; % Width of the section. 
pathData = '.\Data\TD21_S1_G3\';
pathRsultsFolder = '.\Results\TD21_S1_G3\';
files = {'TD21_S1-G3_02_00_001.mat'  'TD21_S1-G3_02_00_002.mat' 'TD21_S1-G3_02_00_003.mat'} ;
file0 = 'TD21_S1-G3_02_00_000.mat';
staticCoeffs(files,file0,pathRsultsFolder,pathData,B,D,L)
%% TD21_S2_G1
close all
D=50/1000;  % Height of the section
B=740/1000; % Width of the section. 
pathData = '.\Data\TD21_S2_G1\';
pathRsultsFolder = '.\Results\TD21_S2_G1\';
files = {'TD21_S2-G1_02_00_001.mat'  'TD21_S2-G1_02_00_002.mat' 'TD21_S2-G1_02_00_003.mat'} ;
file0 = 'TD21_S2-G1_02_00_000.mat';
staticCoeffs(files,file0,pathRsultsFolder,pathData,B,D,L)
%% TD21_S2_G2
close all
D=50/1000;  % Height of the section
B=840/1000; % Width of the section. 
pathData = '.\Data\TD21_S2_G2\';
pathRsultsFolder = '.\Results\TD21_S2_G2\';
files = {'TD21_S2-G2_02_00_005.mat'  'TD21_S2-G2_02_00_002.mat' 'TD21_S2-G2_02_00_003.mat'} ;
file0 = 'TD21_S2-G2_02_00_000.mat';
staticCoeffs(files,file0,pathRsultsFolder,pathData,B,D,L)
%% TD21_S2_G3
close all
D=50/1000;  % Height of the section
B=940/1000; % Width of the section. 
pathData = '.\Data\TD21_S2_G3\';
pathRsultsFolder = '.\Results\TD21_S2_G3\';
files = {'TD21_S2-G3_02_00_008.mat'  'TD21_S2-G3_02_00_009.mat' 'TD21_S2-G3_02_00_010.mat'} ;
file0 = 'TD21_S2-G3_02_00_007.mat';
staticCoeffs(files,file0,pathRsultsFolder,pathData,B,D,L)
%% TD21_S3_G1
close all
D=50/1000;  % Height of the section
B=730/1000; % Width of the section. 
pathData = '.\Data\TD21_S3_G1\';
pathRsultsFolder = '.\Results\TD21_S3_G1\';
files = {'TD21_S3-G1_02_00_001.mat'  'TD21_S3-G1_02_00_002.mat' 'TD21_S3-G1_02_00_003.mat'} ;
file0 = 'TD21_S3-G1_02_00_000.mat';
staticCoeffs(files,file0,pathRsultsFolder,pathData,B,D,L)
%% TD21_S3_G2
close all
D=50/1000;  % Height of the section
B=830/1000; % Width of the section. 
pathData = '.\Data\TD21_S3_G2\';
pathRsultsFolder = '.\Results\TD21_S3_G2\';
files = {'TD21_S3-G2_02_00_004.mat'  'TD21_S3-G2_02_00_005.mat' 'TD21_S3-G2_02_00_006.mat'} ;
file0 = 'TD21_S3-G2_02_00_000.mat';
staticCoeffs(files,file0,pathRsultsFolder,pathData,B,D,L)
%% TD21_S3_G3
close all
D=50/1000;  % Height of the section
B=930/1000; % Width of the section. 
pathData = '.\Data\TD21_S3_G3\';
pathRsultsFolder = '.\Results\TD21_S3_G3\';
files = {'TD21_S3-G3_02_00_008.mat'  'TD21_S3-G3_02_00_009.mat' 'TD21_S3-G3_02_00_010.mat'} ;
file0 = 'TD21_S3-G3_02_00_006.mat';
staticCoeffs(files,file0,pathRsultsFolder,pathData,B,D,L)
%%

function [] = staticCoeffs(files,file0,pathRsultsFolder,pathData,B,D,L)
fullPath0 = [pathData file0];
for nn = 1:length(files)
    fullPath = [pathData files{1,nn} ];
    [t, u0, FG4c0, U0, u, FG4c, U, rho,Fs] = w3t.post.import2datasets(fullPath0, fullPath);
    [~, pos] = max(abs(u(:,3))'.*(1-linspace(0,1,size(u,1))));
    start = pos/Fs-15;
    stop = start + 120;
    [Us, us, CD, CL, CM, CD_raw, CL_raw, CM_raw] = w3t.post.quasisteady2fcoeff(t, FG4c0, u, FG4c, U, rho, D, B, L, start, stop);
    alpha = us(:,3)*360/2/pi;
    h = figure(100);
    h.Units = 'centimeters';
    h.Position = [10 10 25 8];
    hold on
    subplot(1,3,1); plot(alpha,CD,'-','DisplayName',['V=' num2str(round(10*mean(Us))/10)]); grid on; subplot(1,3,2); plot(alpha,CL,'-','DisplayName',['V=' num2str(round(10*mean(Us))/10)]); grid on;  subplot(1,3,3); plot(alpha,CM,'-','DisplayName',['V=' num2str(round(10*mean(Us))/10)]); grid on;
    h.Children(1).NextPlot = 'add'; h.Children(2).NextPlot = 'add'; h.Children(3).NextPlot = 'add';
    h2 = figure;
    h2.Units = 'centimeters';
    h2.Position = [10 10 25 8];
    hold on
    subplot(1,3,1); plot(alpha,CD_raw,'-','DisplayName',['V=' num2str(round(10*mean(Us))/10)],'Color',[0.86 0.86 0.86]); grid on; subplot(1,3,2); plot(alpha,CL_raw,'-','DisplayName',['V=' num2str(round(10*mean(Us))/10)],'Color',[0.86 0.86 0.86]); grid on;  subplot(1,3,3); plot(alpha,CM_raw,'-','DisplayName',['V=' num2str(round(10*mean(Us))/10)],'Color',[0.86 0.86 0.86]); grid on;
    h2.Children(1).NextPlot = 'add'; h2.Children(2).NextPlot = 'add'; h2.Children(3).NextPlot = 'add';
    h2.Children(1).ColorOrderIndex=1; h2.Children(2).ColorOrderIndex=1; h2.Children(3).ColorOrderIndex=1;
    h2.Children(2).Title.String = strrep(files{1,nn}(1:10), '_', ' ');
    subplot(1,3,1); plot(alpha,CD,'-','DisplayName',['V=' num2str(round(10*mean(Us))/10)]); grid on; subplot(1,3,2); plot(alpha,CL,'-','DisplayName',['V=' num2str(round(10*mean(Us))/10)]); grid on;  subplot(1,3,3); plot(alpha,CM,'-','DisplayName',['V=' num2str(round(10*mean(Us))/10)]); grid on;
    for k =1:3; xlim(subplot(1,3,k),[-8 8]); xticks(subplot(1,3,k),linspace(-8,8, 9)); xlabel('$\alpha (deg)$','Interpreter','latex'); end
    ylabel(subplot(1,3,1),'$C_{D}(\alpha)$','Interpreter','latex')
    ylabel(subplot(1,3,2),'$C_{L}(\alpha)$','Interpreter','latex')
    ylabel(subplot(1,3,3),'$C_{M}(\alpha)$','Interpreter','latex')
    legend(h2.Children(1).Children(1),'Location','SouthEast')
    
    w3t.post.awesomefig('filename',[pathRsultsFolder 'SCOF_' files{1,nn}(1:10) '_' num2str(nn)],'w','1.5col','h',5,'format','jpeg','Fontsize',7,'graphwidth',1)
    T = table(alpha, CD, CL, CM);
    writetable(T,[pathRsultsFolder 'StaticCoefficients_' files{1,1}(1:10) '.xls'],'sheet',['Wind Velocity ' 'V=' num2str(round(10*mean(Us))/10) 'ms^-1'])
end

figure(100)
for k =1:3; xlim(subplot(1,3,k),[-8 8]); xticks(subplot(1,3,k),linspace(-8,8, 9)); xlabel('$\alpha (deg)$','Interpreter','latex'); end
ylabel(subplot(1,3,1),'$C_{D}(\alpha)$','Interpreter','latex')
ylabel(subplot(1,3,2),'$C_{L}(\alpha)$','Interpreter','latex')
ylabel(subplot(1,3,3),'$C_{M}(\alpha)$','Interpreter','latex')
h.Children(2).Title.String = strrep(files{1,nn}(1:10), '_', ' ');
legend(subplot(1,3,3),'Location','SouthEast')

w3t.post.awesomefig('filename',[pathRsultsFolder 'SCOF_' files{1,nn}(1:10)],'w','1.5col','h',5,'format','jpeg','Fontsize',7,'graphwidth',1)
end

